# Beispielprogramm für das Buch "Python lernen kurz und gut"
#
# (C) 2023 Michael Inden
from enum import Enum, auto

http_code = 418
match http_code:
    case 200:
        print("OK")
    case 201:
        print("CREATED")
    case 404:
        print("NOT FOUND")
    case 418:
        print("I AM A TEAPOT")
    case _:
        print("UNMATCHED CODE")


def get_info(day):
    match day:
        case 'Monday':
            return "I don't like..."
        case 'Thursday' | 'Friday':
            return 'Nearly there!'
        case 'Saturday' | 'Sunday':
            return 'Weekend!!!'
        case _:
            return 'In Between...'


print(get_info("Monday"))
print(get_info("Friday"))


class Gender(Enum):
    MALE = auto()
    FEMALE = auto()


def classify(person):
    match person:
        case (name, age, "male" | Gender.MALE):
            print(f"{name} is a man and {age} years old")
        case (name, age, "female" | Gender.FEMALE):
            print(f"{name} is a woman and {age} years old")
        case (name, _, gender) if gender is not None:
            print(f"no age specified: {name} is {gender}")
        case (name, age, _) if age is not None:
            print(f"no gender specified: {name} is"
                  f" {age} years old.")


classify(("Micha", 50, "male"))
classify(("Lili", 42, Gender.FEMALE))
classify(("NO GENDER", 42, None))
classify(("NO AGE", None, "ALL"))
