# Beispielprogramm für das Buch "Python lernen kurz und gut"
#
# (C) 2023 Michael Inden

from enum import Enum
from collections import namedtuple

Person = namedtuple('Person', 'name age gender')

dxdy = namedtuple('dxdy', ['dx', 'dy'])

class DirectionV2(Enum):
    N = dxdy(0, -1)
    NE = dxdy(1, -1)
    E = dxdy(1, 0)
    SE = dxdy(1, 1)
    S = dxdy(0, 1)
    SW = dxdy(-1, 1)
    W = dxdy(-1, 0)
    NW = dxdy(-1, -1)


print(DirectionV2.NE.value)
ne = DirectionV2.NE
print(ne.value.dx, "/", ne.value.dy)


try:
    namedtuple('Person', 'name class age gender')
except ValueError as err:
    print(err)

try:
    namedtuple('Person', 'name age gender age')
except ValueError as err:
    print(err)


Point = namedtuple('Point', 'x y')
pt1 = Point(1.0, 5.0)
pt2 = Point(2.5, 1.5)

from math import sqrt
# Zugriff über den Index
line_length = sqrt((pt1[0]-pt2[0])**2 + (pt1[1]-pt2[1])**2)
# Tuple Unpacking
x1, y1 = pt1
print(pt1, x1, y1)