# Beispielprogramm für das Buch "Python lernen kurz und gut"
#
# (C) 2023 Michael Inden

def initialize_board():
    board = [['-' for col in range(3)] for row in range(3)]
    return board


def print_board(board):
    print("-------------")

    for row in range(3):
        print("| ", end="")
        for col in range(3):
            print(board[row][col] + " | ", end="")
        print()
        print("-------------")


tictactoe_board = initialize_board()
print_board(tictactoe_board)


def place_mark(board, row, col, current_player_mark):
    if board[row][col] == '-':
        board[row][col] = current_player_mark
        return True
    return False


##################################################################
# GAME PLAY I
##################################################################
place_mark(tictactoe_board, 0, 0, 'X')
place_mark(tictactoe_board, 1, 1, 'O')
place_mark(tictactoe_board, 0, 1, 'X')
print_board(tictactoe_board)


def check_for_win(board, current_player_mark):
    return check_rows_for_win(board, current_player_mark) or \
        check_columns_for_win(board, current_player_mark) or \
        check_diagonals_for_win(board, current_player_mark)


def check_rows_for_win(board, current_player_mark):
    for row in range(3):
        if check_all_same(board[row][0], board[row][1], board[row][2], current_player_mark):
            return True
    return False


def check_columns_for_win(board, current_player_mark):
    for col in range(3):
        if check_all_same(board[0][col], board[1][col], board[2][col], current_player_mark):
            return True
    return False


def check_diagonals_for_win(board, current_player_mark):
    return check_all_same(board[0][0], board[1][1], board[2][2], current_player_mark) or \
        check_all_same(board[0][2], board[1][1], board[2][0], current_player_mark)


def check_all_same(cell1, cell2, cell3, current_player_mark):
    return cell1 == current_player_mark and cell1 == cell3 and cell2 == cell3


##################################################################
# GAME PLAY II
##################################################################
place_mark(tictactoe_board, 2, 1, 'O')
place_mark(tictactoe_board, 0, 2, 'X')
print_board(tictactoe_board)

print("Winner O?", check_for_win(tictactoe_board, 'O'))
print("Winner X?", check_for_win(tictactoe_board, 'X'))


def print_board_nicer(board):
    for row in range(3):
        for col in range(3):
            print(" " + str(board[row][col]) + " ", end="")
            if col < 2:
                print("|", end="")
        if row < 2:
            print()
            print("---+---+---")


print_board_nicer(tictactoe_board)
